/* A/D prevodnik
 *
 * Changelog:
 * 2006-10-24: Zalozeno (z battery.h). Slouzi pouze pro vycitani potenciometru
 */

#include "globals.h"
#include "ad.h"

/*
 * V softune/lib/907/include/sample/_f16lxr.h je treba do struktury io_adcs1
 * doplnit bit STRT hned nad STS, tedy nahradit radek 
 * __UCHARBIT_NONAME(    1)
 * 		radkem
 *	__UCHARBIT(	STRT, 1)
 */

void
ad_init(void)
{
	POTPORT = 1; /* Analogovy pristup */
	IO_ADCS0.bit.MD = 0; /* Mod -- single */

	IO_ADCS0.bit.ANS = POTPIN; /* Start pin */
	IO_ADCS0.bit.ANE = POTPIN; /* End pin */

	IO_ADCS1.bit.INTE = 0; /* No interrupts */
	IO_ADCS1.bit.STS = 0; /* Software activation */

}

/* vraci word -- hodnotu a/d prevodniku na kterem je pripojeno napajeni, v
 * rozsahu 0 .. 1023 (a to i presto ze mame 8 bit sampling) */
word
ad_get_val(void)
{
	IO_ADCS1.bit.BUSY = 0; /* Terminate */
	IO_ADCR01.byte.ADCR1 = 0x08; /* 8 bit, 64 cycles sampling, 352 cycles comparing */
	IO_ADCS1.bit.STRT = 1; /* Odstartujem */
	while(IO_ADCS1.bit.BUSY); /* Pockame do konce prevodu */
	return IO_ADCR01.DATA10;
}
