#include "globals.h"
#include "misc.h"
#include "buzzer.h"
#include "panel.h"
#include "rtc.h"
#include "timer.h"
#include "buzzer.h"
#include "sleep.h"
#include "gpib.h"
#include "luxmetr.h"
#include "p_num_x_x.h"
#include "ui.h"
#include "uart.h"
#include "cmos.h"
#include "arm.h"
#include "table.h"
#include "ad.h"
	
void
main(void) 
{
	ports_init();
	ad_init();
	p_init();
	rtc_init();
	support_init();
	buzzer_init();
	set_pll(true);
	
	ui();
}
